Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl_rst.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl_rst.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl_rst.F90	(revision 10986)
@@ -65,4 +65,5 @@
             ELSE                          ;   WRITE(numout,*) '             kt = '             , kt,' date= ', ndastp
             ENDIF
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -75,4 +76,5 @@
          WRITE(numout,*) '~~~~~~~~~~'
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -139,4 +141,5 @@
          WRITE(numout,*) ' trd_mxl_rst_read : read the NetCDF mixed layer trend restart file'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdpen.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdpen.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdpen.F90	(revision 10986)
@@ -140,4 +140,5 @@
          WRITE(numout,*) 'trd_pen_init : 3D Potential ENergy trends'
          WRITE(numout,*) '~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                           ! allocate box volume arrays
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdvor.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdvor.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdvor.F90	(revision 10986)
@@ -200,6 +200,8 @@
 
       IF( ndebug /= 0 ) THEN
-         IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
-         CALL FLUSH(numout)
+         IF(lwp) THEN
+            WRITE(numout,*) ' debuging trd_vor_zint: I done'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
       !
@@ -291,6 +293,8 @@
    
       IF( ndebug /= 0 ) THEN
-         IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
-         CALL FLUSH(numout)
+         IF(lwp) THEN
+            WRITE(numout,*) ' debuging trd_vor_zint: I done'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
       !
@@ -416,4 +420,5 @@
             WRITE(numout,*) 'trd_vor : write trends in the NetCDF file at kt = ', kt
             WRITE(numout,*) '~~~~~~~  '
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
  
@@ -434,5 +439,5 @@
          IF( ndebug /= 0 ) THEN
             WRITE(numout,*) ' debuging trd_vor: III.4 done'
-            CALL FLUSH(numout)
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          !
@@ -477,4 +482,5 @@
          WRITE(numout,*) '               ##########################################################################'
          WRITE(numout,*) ' '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -490,5 +496,5 @@
       IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor_init: I. done'
-         CALL FLUSH(numout)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -512,5 +518,8 @@
       zout = nn_trd*rdt
 
-      IF(lwp) WRITE(numout,*) '               netCDF initialization'
+      IF(lwp) THEN
+         WRITE(numout,*) '               netCDF initialization'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       ! II.2 Compute julian date from starting date of the run
@@ -518,13 +527,19 @@
       CALL ymds2ju( nyear, nmonth, nday, rdt, zjulian )
       zjulian = zjulian - adatrj   !   set calendar origin to the beginning of the experiment
-      IF(lwp) WRITE(numout,*)' '  
-      IF(lwp) WRITE(numout,*)'               Date 0 used :',nit000,    &
+      IF(lwp) THEN
+         WRITE(numout,*)' '  
+         WRITE(numout,*)'               Date 0 used :',nit000,    &
          &                   ' YEAR ', nyear,' MONTH '      , nmonth,   &
          &                   ' DAY ' , nday, 'Julian day : ', zjulian
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       ! II.3 Define the T grid trend file (nidvor)
       ! ---------------------------------
       CALL dia_nam( clhstnam, nn_trd, 'vort' )                  ! filename
-      IF(lwp) WRITE(numout,*) ' Name of NETCDF file ', clhstnam
+      IF(lwp) THEN
+         WRITE(numout,*) ' Name of NETCDF file ', clhstnam
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       CALL histbeg( clhstnam, jpi, glamf, jpj, gphif,1, jpi,   &  ! Horizontal grid : glamt and gphit
          &          1, jpj, nit000-1, zjulian, rdt, nh_t, nidvor, domain_id=nidom, snc4chunks=snc4set )
@@ -562,5 +577,5 @@
       IF( ndebug /= 0 ) THEN
          WRITE(numout,*) ' debuging trd_vor_init: II. done'
-         CALL FLUSH(numout)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfdrg.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfdrg.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfdrg.F90	(revision 10986)
@@ -254,4 +254,5 @@
          WRITE(numout,*) '      logarithmic drag: Cd = vkarmn/log(z/z0)   ln_loglayer = ', ln_loglayer
          WRITE(numout,*) '      implicit friction                         ln_drgimp   = ', ln_drgimp
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -356,4 +357,5 @@
          WRITE(numout,*) '      set a regional boost of Cd0             ln_boost = ', ln_boost
          WRITE(numout,*) '         associated boost factor              rn_boost = ', rn_boost
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -367,7 +369,10 @@
       !
       IF( ln_boost ) THEN           !* regional boost:   boost factor = 1 + regional boost
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '   ==>>>   use a regional boost read in ', TRIM(cl_file), ' file'
-         IF(lwp) WRITE(numout,*) '           using enhancement factor of ', rn_boost
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '   ==>>>   use a regional boost read in ', TRIM(cl_file), ' file'
+            WRITE(numout,*) '           using enhancement factor of ', rn_boost
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          ! cl_varname is a coefficient in [0,1] giving where to apply the regional boost
          CALL iom_open ( TRIM(cl_file), inum )
@@ -451,4 +456,5 @@
          CALL ctl_stop( 'drg_init: bad flag value for ndrg ' )
       END SELECT
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
       !
    END SUBROUTINE drg_init
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfevd.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfevd.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfevd.F90	(revision 10986)
@@ -62,9 +62,10 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'zdf_evd : Enhanced Vertical Diffusion (evd)'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
-         IF(lwp) WRITE(numout,*)
+      IF( kt == nit000 .AND. lwp) THEN
+          WRITE(numout,*)
+          WRITE(numout,*) 'zdf_evd : Enhanced Vertical Diffusion (evd)'
+          WRITE(numout,*) '~~~~~~~ '
+          WRITE(numout,*)
+          IF(lflush) CALL FLUSH(numout) 
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfgls.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfgls.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfgls.F90	(revision 10986)
@@ -890,4 +890,5 @@
          WRITE(numout,*) '      Bottom seafloor     roughness (m)             rn_z0(_bot)   = ', r_z0_bot
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -982,5 +983,5 @@
          !
       END SELECT
-
+      IF(lflush .AND. lwp) CALL FLUSH(numout)
       !
       SELECT CASE ( nn_stab_func )     !* set the parameters of the stability functions
@@ -1058,4 +1059,5 @@
          !
       END SELECT
+      IF(lflush .AND. lwp) CALL FLUSH(numout)
     
       !                                !* Set Schmidt number for psi diffusion in the wave breaking case
@@ -1107,4 +1109,5 @@
          WRITE(numout,*) '      ra_sf    = ', ra_sf
          WRITE(numout,*) '      rl_sf    = ', rl_sf
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -1177,6 +1180,9 @@
                CALL iom_get( numror, jpdom_autoglo, 'hmxl_n', hmxl_n, ldxios = lrxios )
             ELSE                        
-               IF(lwp) WRITE(numout,*)
-               IF(lwp) WRITE(numout,*) '   ==>>   previous run without GLS scheme, set en and hmxl_n to background values'
+               IF(lwp) THEN
+                  WRITE(numout,*)
+                  WRITE(numout,*) '   ==>>   previous run without GLS scheme, set en and hmxl_n to background values'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                en    (:,:,:) = rn_emin
                hmxl_n(:,:,:) = 0.05_wp
@@ -1184,6 +1190,9 @@
             ENDIF
          ELSE                                   !* Start from rest
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '   ==>>   start from rest, set en and hmxl_n by background values'
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '   ==>>   start from rest, set en and hmxl_n by background values'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             en    (:,:,:) = rn_emin
             hmxl_n(:,:,:) = 0.05_wp
@@ -1193,5 +1202,8 @@
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
          !                                   ! -------------------
-         IF(lwp) WRITE(numout,*) '---- gls-rst ----'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '---- gls-rst ----'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( lwxios ) CALL iom_swap(      cwxios_context         )
          CALL iom_rstput( kt, nitrst, numrow, 'en'    , en    , ldxios = lwxios )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfiwm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfiwm.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfiwm.F90	(revision 10986)
@@ -328,4 +328,5 @@
             WRITE(numout,*)
             WRITE(numout,*) '      Total power consumption by av_wave =  ', zztmp * 1.e-12_wp, 'TW'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
       ENDIF
@@ -439,4 +440,5 @@
          WRITE(numout,*) '      Variable (T) or constant (F) mixing efficiency            = ', ln_mevar
          WRITE(numout,*) '      Differential internal wave-driven mixing (T) or not (F)   = ', ln_tsdiff
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       
@@ -451,4 +453,5 @@
          WRITE(numout,*) '   Force the background value applied to avm & avt in TKE to be everywhere ',   &
             &               'the viscous molecular value & a very small diffusive value, resp.'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
             
@@ -488,4 +491,5 @@
          WRITE(numout,*) '      Pycnocline-intensifed wave-breaking energy: ', zpyc * 1.e-12_wp, 'TW'
          WRITE(numout,*) '      Critical slope wave-breaking energy:        ', zcri * 1.e-12_wp, 'TW'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfmxl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfmxl.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfmxl.F90	(revision 10986)
@@ -86,4 +86,5 @@
          IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
          IF(lwp) WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
          !                             ! allocate zdfmxl arrays
          IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfosm.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfosm.F90	(revision 10986)
@@ -1418,4 +1418,5 @@
         WRITE(numout,*) '     Use large mixing below BL when unstable       ln_convmix = ', ln_convmix
         WRITE(numout,*) '     diffusivity when unstable below BL     (m2/s) rn_difconv = ', rn_difconv
+        IF(lflush) CALL FLUSH(numout)
      ENDIF
 
@@ -1430,4 +1431,5 @@
            WRITE(numout,*) '    Double diffusion mixing on temperature and salinity '
            WRITE(numout,*) '    CAUTION : done in routine zdfosm, not in routine zdfddm '
+           IF(lflush) CALL FLUSH(numout)
         ENDIF
      ENDIF
@@ -1439,4 +1441,5 @@
      IF(lwp) THEN
         WRITE(numout,*)
+        IF(lflush) CALL FLUSH(numout)
      ENDIF
 
@@ -1495,5 +1498,5 @@
 
      END SELECT
-
+     IF(lwp .AND. lflush) CALL FLUSH(numout)
      ! Initialization of vertical eddy coef. to the background value
      ! -------------------------------------------------------------
@@ -1546,8 +1549,14 @@
         IF( id1 > 0 ) THEN                       ! 'wn' exists; read
            CALL iom_get( numror, jpdom_autoglo, 'wn', wn, ldxios = lrxios )
-           WRITE(numout,*) ' ===>>>> :  wn read from restart file'
+           IF(lwp) THEN
+              WRITE(numout,*) ' ===>>>> :  wn read from restart file'
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
         ELSE
            wn(:,:,:) = 0._wp
-           WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
+           IF(lwp) THEN
+              WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
         END IF
         id1 = iom_varid( numror, 'hbl'   , ldstop = .FALSE. )
@@ -1556,8 +1565,14 @@
            CALL iom_get( numror, jpdom_autoglo, 'hbl' , hbl , ldxios = lrxios )
            CALL iom_get( numror, jpdom_autoglo, 'hbli', hbli, ldxios = lrxios  )
-           WRITE(numout,*) ' ===>>>> :  hbl & hbli read from restart file'
+           IF(lwp) THEN
+              WRITE(numout,*) ' ===>>>> :  hbl & hbli read from restart file'
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
            RETURN
         ELSE                      ! 'hbl' & 'hbli' not in restart file, recalculate
-           WRITE(numout,*) ' ===>>>> : previous run without osmosis scheme, hbl computed from stratification'
+           IF(lwp) THEN
+              WRITE(numout,*) ' ===>>>> : previous run without osmosis scheme, hbl computed from stratification'
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
         END IF
      END IF
@@ -1567,5 +1582,8 @@
      !!-----------------------------------------------------------------------------
      IF( TRIM(cdrw) == 'WRITE') THEN     !* Write hbli into the restart file, then return
-        IF(lwp) WRITE(numout,*) '---- osm-rst ----'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '---- osm-rst ----'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          CALL iom_rstput( kt, nitrst, numrow, 'wn'     , wn  , ldxios = lwxios )
          CALL iom_rstput( kt, nitrst, numrow, 'hbl'    , hbl , ldxios = lwxios )
@@ -1577,5 +1595,8 @@
      ! Getting hbl, no restart file with hbl, so calculate from surface stratification
      !!-----------------------------------------------------------------------------
-     IF( lwp ) WRITE(numout,*) ' ===>>>> : calculating hbl computed from stratification'
+     IF( lwp ) THEN
+        WRITE(numout,*) ' ===>>>> : calculating hbl computed from stratification'
+        IF(lflush) CALL FLUSH(numout)
+     ENDIF
      ALLOCATE( imld_rst(jpi,jpj) )
      ! w-level of the mixing and mixed layers
@@ -1606,5 +1627,8 @@
      hbli(:,:) = hbl(:,:)
      DEALLOCATE( imld_rst )
-     WRITE(numout,*) ' ===>>>> : hbl computed from stratification'
+     IF(lwp) THEN
+        WRITE(numout,*) ' ===>>>> : hbl computed from stratification'
+        IF(lflush) CALL FLUSH(numout)
+     ENDIF
    END SUBROUTINE osm_rst
 
@@ -1623,8 +1647,9 @@
       INTEGER :: ji, jj, jk
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_osm : OSM non-local tracer fluxes'
-         IF(lwp) WRITE(numout,*) '~~~~~~~   '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_osm : OSM non-local tracer fluxes'
+         WRITE(numout,*) '~~~~~~~   '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -1698,8 +1723,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_osm : OSM non-local velocity'
-         IF(lwp) WRITE(numout,*) '~~~~~~~   '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn_osm : OSM non-local velocity'
+         WRITE(numout,*) '~~~~~~~   '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !code saving tracer trends removed, replace with trdmxl_oce
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfphy.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfphy.F90	(revision 10986)
@@ -88,4 +88,5 @@
          WRITE(numout,*) 'zdf_phy_init: ocean vertical physics'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -128,4 +129,5 @@
          WRITE(numout,*) '         constant background or profile          nn_avb    = ', nn_avb
          WRITE(numout,*) '         horizontal variation for avtb           nn_havtb  = ', nn_havtb
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -178,4 +180,5 @@
          ELSE                      ;   WRITE(numout,*) '   ==>>>   convection: no specific scheme used'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -185,4 +188,5 @@
          ELSE                   ;   WRITE(numout,*) '   ==>>>   No  double diffusive mixing: avs = avt'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfric.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfric.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfric.F90	(revision 10986)
@@ -101,4 +101,5 @@
          WRITE(numout,*) '         Vertical eddy Diff. in the ML  rn_wtmix  = ', rn_wtmix
          WRITE(numout,*) '         Vertical eddy Visc. in the ML  rn_wvmix  = ', rn_wvmix
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -234,5 +235,8 @@
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
          !                                   ! -------------------
-         IF(lwp) WRITE(numout,*) '---- ric-rst ----'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '---- ric-rst ----'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( lwxios ) CALL iom_swap(      cwxios_context          )
          CALL iom_rstput( kt, nitrst, numrow, 'avt_k', avt_k, ldxios = lwxios )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfswm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfswm.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdfswm.F90	(revision 10986)
@@ -88,4 +88,5 @@
          WRITE(numout,*) 'zdf_swm_init : surface wave-driven mixing'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       IF(  .NOT.ln_wave .OR.   &
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdftke.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdftke.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/ZDF/zdftke.F90	(revision 10986)
@@ -699,4 +699,5 @@
          WRITE(numout,*) '   ==>>>   critical Richardson nb with your parameters  ri_cri = ', ri_cri
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -704,8 +705,14 @@
          rn_emin  = 1.e-10_wp             ! specific values of rn_emin & rmxl_min are used
          rmxl_min = 1.e-03_wp             ! associated avt minimum = molecular salt diffusivity (10^-9 m2/s)
-         IF(lwp) WRITE(numout,*) '   ==>>>   Internal wave-driven mixing case:   force   rn_emin = 1.e-10 and rmxl_min = 1.e-3'
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   Internal wave-driven mixing case:   force   rn_emin = 1.e-10 and rmxl_min = 1.e-3'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ELSE                          ! standard case : associated avt minimum = molecular viscosity (10^-6 m2/s)
          rmxl_min = 1.e-6_wp / ( rn_ediff * SQRT( rn_emin ) )    ! resulting minimum length to recover molecular viscosity
-         IF(lwp) WRITE(numout,*) '   ==>>>   minimum mixing length with your parameters rmxl_min = ', rmxl_min
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   minimum mixing length with your parameters rmxl_min = ', rmxl_min
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
       !
@@ -720,6 +727,9 @@
       !
       IF( ln_mxl0 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '   ==>>>   use a surface mixing length = F(stress) :   set rn_mxl0 = rmxl_min'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '   ==>>>   use a surface mixing length = F(stress) :   set rn_mxl0 = rmxl_min'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          rn_mxl0 = rmxl_min
       ENDIF
@@ -781,6 +791,9 @@
                CALL iom_get( numror, jpdom_autoglo, 'dissl', dissl, ldxios = lrxios )
             ELSE                                          ! start TKE from rest
-               IF(lwp) WRITE(numout,*)
-               IF(lwp) WRITE(numout,*) '   ==>>>   previous run without TKE scheme, set en to background values'
+               IF(lwp) THEN
+                  WRITE(numout,*)
+                  WRITE(numout,*) '   ==>>>   previous run without TKE scheme, set en to background values'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                en   (:,:,:) = rn_emin * wmask(:,:,:)
                dissl(:,:,:) = 1.e-12_wp
@@ -788,6 +801,9 @@
             ENDIF
          ELSE                                   !* Start from rest
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '   ==>>>   start from rest: set en to the background value'
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '   ==>>>   start from rest: set en to the background value'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             en   (:,:,:) = rn_emin * wmask(:,:,:)
             dissl(:,:,:) = 1.e-12_wp
@@ -797,5 +813,8 @@
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
          !                                   ! -------------------
-         IF(lwp .AND. nprint > 0) WRITE(numout,*) '---- tke_rst ----'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '---- tke_rst ----'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( lwxios ) CALL iom_swap(      cwxios_context          ) 
          CALL iom_rstput( kt, nitrst, numrow, 'en'   , en   , ldxios = lwxios )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/nemogcm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/nemogcm.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/nemogcm.F90	(revision 10986)
@@ -225,4 +225,5 @@
          WRITE(numout,*) '   ==>>>   nemo_gcm: a total of ', nstop, ' errors have been found'
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -261,5 +262,5 @@
       NAMELIST/namctl/ ln_ctl   , sn_cfctl, nn_print, nn_ictls, nn_ictle,   &
          &             nn_isplt , nn_jsplt, nn_jctls, nn_jctle,             &
-         &             ln_timing, ln_diacfl
+         &             ln_timing, ln_diacfl, ln_flush
       NAMELIST/namcfg/ ln_read_cfg, cn_domcfg, ln_closea, ln_write_cfg, cn_domcfg_out, ln_use_jattr
       !!----------------------------------------------------------------------
@@ -393,4 +394,5 @@
          !
          IF(nprint > 1) WRITE(numout,cform_aaa)                                        ! Flag AAAAAAA
+         IF(lflush) CALL FLUSH(numout)
          !
       ENDIF
@@ -497,5 +499,8 @@
       IF( lk_asminc    )   CALL asm_inc_init    ! Initialize assimilation increments
       !
-      IF(lwp .AND. nprint > 1) WRITE(numout,cform_aaa)           ! Flag AAAAAAA
+      IF(lwp .AND. nprint > 1) THEN
+         WRITE(numout,cform_aaa)           ! Flag AAAAAAA
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       IF( ln_timing    )   CALL timing_stop( 'nemo_init')
@@ -541,4 +546,5 @@
       ENDIF
       !
+      lflush    = ln_flush
       nictls    = nn_ictls
       nictle    = nn_ictle
@@ -557,4 +563,5 @@
          WRITE(numout,*) '         filename to be written                        cn_domcfg_out = ', TRIM(cn_domcfg_out)
          WRITE(numout,*) '      use file attribute if exists as i/p j-start   ln_use_jattr     = ', ln_use_jattr
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       IF( .NOT.ln_read_cfg )   ln_closea = .false.   ! dealing possible only with a domcfg file
@@ -572,6 +579,9 @@
             ijsplt = isplt * jsplt            ! total number of processors ijsplt
          ENDIF
-         IF(lwp) WRITE(numout,*)'          - The total number of processors over which the'
-         IF(lwp) WRITE(numout,*)'            print control will be done is ijsplt : ', ijsplt
+         IF(lwp) THEN
+            WRITE(numout,*)'          - The total number of processors over which the'
+            WRITE(numout,*)'            print control will be done is ijsplt : ', ijsplt
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          !                              ! indices used for the SUM control
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/stpctl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/stpctl.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/stpctl.F90	(revision 10986)
@@ -78,4 +78,5 @@
          WRITE(numout,*) 'stp_ctl : time-stepping control'
          WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
          !                                ! open time.step file
          IF( lwm ) CALL ctl_opn( numstp, 'time.step', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
@@ -133,4 +134,5 @@
       IF( ll_wrtruns ) THEN
          WRITE(numrun,9500) kt, zmax(1), zmax(2), -zmax(3), zmax(4)
+         IF(lflush) CALL flush(numrun)
          istatus = NF90_PUT_VAR( idrun, idssh, (/ zmax(1)/), (/kt/), (/1/) )
          istatus = NF90_PUT_VAR( idrun,   idu, (/ zmax(2)/), (/kt/), (/1/) )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/timing.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/timing.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/timing.F90	(revision 10986)
@@ -815,5 +815,8 @@
       !
       IF( ASSOCIATED(ptr%next) ) CALL timing_list(ptr%next)
-      IF(lwp) WRITE(numout,*)'   ', ptr%cname   
+      IF(lwp) THEN
+         WRITE(numout,*)'   ', ptr%cname   
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
    END SUBROUTINE timing_list
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/trc_oce.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/trc_oce.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/trc_oce.F90	(revision 10986)
@@ -86,4 +86,5 @@
          WRITE(numout,*) '   trc_oce_rgb : Initialisation of the optical look-up table'
          WRITE(numout,*) '   ~~~~~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -154,10 +155,16 @@
       !
       r_si2 = 1.e0 / zrgb(2, 1)        ! blue with the smallest chlorophyll concentration)
-      IF(lwp) WRITE(numout,*) '      RGB longest depth of extinction    r_si2 = ', r_si2
+      IF(lwp) THEN
+         WRITE(numout,*) '      RGB longest depth of extinction    r_si2 = ', r_si2
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       DO jc = 1, 61                         ! check
          zchl = zrgb(1,jc)
          irgb = NINT( 41 + 20.* LOG10( zchl ) + 1.e-15 )
-         IF(lwp .AND. nn_print >= 1 ) WRITE(numout,*) '    jc =', jc, '  Chl = ', zchl, '  irgb = ', irgb
+         IF(lwp .AND. nn_print >= 1 ) THEN
+            WRITE(numout,*) '    jc =', jc, '  Chl = ', zchl, '  irgb = ', irgb
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( irgb /= jc ) THEN
             IF(lwp) WRITE(numout,*) '    jc =', jc, '  Chl = ', zchl, '  Chl class = ', irgb
